#Del for generell setup i setupdelen
import wx
class GenSetup(wx.Panel):
	def __init__(self,parent,data):
		wx.Panel.__init__(self,parent,-1)
		self.progData=data
		figbox_title=wx.StaticBox(self,-1,'General Project Setup')
		figbox_title.SetFont(wx.Font(13,wx.FONTFAMILY_MODERN, wx.FONTSTYLE_NORMAL,wx.FONTWEIGHT_BOLD,False))
		figbox=wx.StaticBoxSizer(figbox_title, wx.VERTICAL)
		sizFig=wx.FlexGridSizer(cols=2,hgap=5,vgap=10)
		self.proFileL=wx.StaticText(self,-1, 'Project File:')
		self.proFileT=wx.StaticText(self,-1, self.progData[1]+'/'+self.progData[0]+'.bpr')
		self.proTitleL=wx.StaticText(self,-1, 'Project Title:')
		self.proTitleT=wx.StaticText(self,-1,self.progData[0])
		self.proDescL=wx.StaticText(self,-1, 'Project Description:')
		self.proDescT=wx.TextCtrl(self,-1,"",size=(255, -1),style=wx.TE_MULTILINE)
        	
        	if self.progData[2]!=None:
        		   self.proDescT.SetValue(self.progData[2])
        		   
        	self.realTimeCheck=wx.CheckBox(self,-1,'Run RealTime')
        	if self.progData[3]!=None:
        		self.realTimeCheck.SetValue(bool(self.progData[3]))
        	self.warnCheck=wx.CheckBox(self,-1,'Show Warnings')
        	if self.progData[4]!=None:
        		self.warnCheck.SetValue(bool(self.progData[4]))
        	self.ssCheck=wx.CheckBox(self,-1,'Show SuperStep Counter')
        	if self.progData[5]!=None:
        		self.ssCheck.SetValue(bool(self.progData[5]))
        	sizFig.Add(self.proFileL)
        	sizFig.Add(self.proFileT)
        	sizFig.Add(self.proTitleL)
        	sizFig.Add(self.proTitleT)
        	sizFig.Add(self.proDescL)
        	sizFig.Add(self.proDescT)
        	sizFig.Add(self.realTimeCheck)
        	sizFig.Add((0,0))
        	sizFig.Add(self.warnCheck)
        	sizFig.Add((0,0))
        	sizFig.Add(self.ssCheck)
        	sizFig.Add((0,0))
    
        	figbox.Add((15,15))
        	figbox.Add(sizFig)
        	self.saveBtn=wx.Button(self,-1,'Save Changes')
        	self.Bind(wx.EVT_BUTTON,self.getData,self.saveBtn)
        	figbox.Add(self.saveBtn)
        	self.SetSizer(figbox)
        	self.SetAutoLayout(True)
        	
        def getData(self,event):
        	
        	
        	self.progData[2]=self.proDescT.GetValue()
        	self.progData[3]=self.realTimeCheck.GetValue()
        	self.progData[4]=self.warnCheck.GetValue()
        	self.progData[5]=self.ssCheck.GetValue()
        	
        	
        	
        	
        		 
		
		
		
		
		
		
		