#Panel that shows plottet figure data 
import wx


class SetupPane(wx.Panel):
	def __init__(self, parent):
		wx.Panel.__init__(self, parent,-1)
                   
		self.dataInTree={}
		self.figDataTree=wx.TreeCtrl(self, -1,wx.DefaultPosition,(150,200),wx.TR_HAS_BUTTONS,
                              )
		self.figBoxTitle=wx.StaticBox(self,-1,'')
		self.figDataBox=wx.StaticBoxSizer(self.figBoxTitle,wx.HORIZONTAL)
		self.root=self.figDataTree.AddRoot('Data in Fig')
		topSiz=wx.BoxSizer(wx.VERTICAL)
		self.figDataTree.Bind(wx.EVT_TREE_SEL_CHANGED, self.change)
                
                
                
                self.l1ValSiz=wx.FlexGridSizer(cols=2)
                self.l1ValSiz.Add(l1Setup(self),1,wx.GROW)
                self.figDataBox.Add(self.figDataTree,1,wx.EXPAND)
                self.figDataBox.Add(self.l1ValSiz,3,wx.EXPAND)
                self.SetSizer(self.figDataBox)
                self.SetAutoLayout(True)
                


                
        def change(self, evt):
            print self.figDataTree.GetItemText(self.figDataTree.GetSelection())
        def deleteAll(self):
            self.figDataTree.DeleteChildren(self.root)
            self.dataInTree={}
        
            
        def addData(self,data):
   
                    
                    if data[0]==1:
                        if data[1][0]!=3:
                            if self.dataInTree.has_key(data[2])==0:
                                next=self.figDataTree.AppendItem(self.root,data[2])
                                self.dataInTree[data[2]]=[[data[1]],next,]
                                x=0
                                liste= data[1][1].keys()
                                l=liste.sort()

                                for element in liste:
                                    l=self.figDataTree.AppendItem(next, 'Pid:'+str(x))
                                    self.figDataTree.SetPyData(l,[1,data[2],element])
                                    x=x+1
                            else:
                                 #print self.dataInTree[data[2]][0]   
                                 self.dataInTree[data[2]][0].append(data[1])
                        else:
                            if self.dataInTree.has_key(data[2])==0:
                                next=self.figDataTree.AppendItem(self.root,data[2])
                                self.dataInTree[data[2]]=[data[1],next]
                    else:
                            
                        if self.dataInTree.has_key(data[3])==0:
                            next=self.figDataTree.AppendItem(self.root,str(data[3]))
                            self.dataInTree[data[3]]=[[data[1],next]]
                            self.figDataTree.AppendItem(next,str(data[2]))
                        else:
                            self.figDataTree.AppendItem(self.dataInTree[data[3]][0][1],str(data[2]))
                            
                    self.figDataTree.Expand(self.root)
                            
                    
                    



                    
                
                
        

class l2Setup(wx.Panel):
    def __init__(self,parent):
        wx.Panel.__init__(self,parent,-1)
        self.test=wx.TextCtrl(self,-1,'TESTL1')
        return self.test
class l1Setup(wx.Panel):
    def __init__(self,parent):
        wx.Panel.__init__(self,parent,-1)
        self.legendGroupL=wx.StaticText(self,-1,'Legend Label')
        self.legendGroupT=wx.TextCtrl(self,-1,'')
        self.l1Siz=wx.GridSizer(cols=3)
        self.l1Siz.Add((0,0))
        self.l1Siz.Add(self.legendGroupL)
        self.l1Siz.Add(self.legendGroupT)
        self.SetSizer(self.l1Siz)
    
        return self
class rem(wx.Panel):
    def __init__(self,parent):
        wx.Panel.__init__(self,parent,-1)
        self.removeBtn=wx.StaticButton(self,-1,'TESTL1')
        return self.test
		
