#This is the main window and parentclass of the system

import wx
import time
import os
import sys
import threading
import ProSetup
import plotSasha
import cPickle



ID_Menu_New         = 5004
ID_Menu_Exit        = 5005

ID_WINDOW_TOP       = 5000
ID_WINDOW_LEFT1     = 5001
ID_WINDOW_LEFT2     = 5002
ID_WINDOW_BOTTOM    = 5003

#----------------------------------------------------------------------
#Hovedvinduet
class MyParentFrame(wx.MDIParentFrame):
    def __init__(self,antPros,parent):
        
            wx.MDIParentFrame.__init__(
            self, None, -1, size=(600,400)
            )
	    os.chdir('c:')	
	
	    self.projectData=[]
            self.parent=parent
            self.pidLista=[]
            self.pid = 0
            self.openProj=False
            self.first=True
            self.setupWin=None
            self.workPath=os.path.dirname(sys.argv[0])
            print self.workPath
            i=1
            while i<=antPros:
                self.pidLista.append([False,[],None])
                i=i+1

            print os.getcwd() 
            menu = wx.Menu()
            menu.AppendSeparator()
            menu.Append(10,"New")
            menu.Append(11,"Open")
            menu.Append(12,"Save")
            menu.AppendSeparator()
            menu.Append(13, "E&xit")
	    
	    menu3 = wx.Menu()
	    menu3.Append(41,"Run Project")
	    
	    self.menu1 = wx.Menu()
	    self.menu1.AppendSeparator()
	    self.menu1.Append(21, "Plot")
	    #menu1.Append(22,"Report")
	    self.menu2 = wx.Menu()
	    self.menu2.Append(31,"Project Setup")
            menubar = wx.MenuBar()
            menubar.Append(menu, "&File")
            menubar.Append(menu3, "&Run")
            menubar.Append(self.menu2, "&Setup")
            menubar.Append(self.menu1, "&Tools")
            self.SetMenuBar(menubar)
	    self.menu2.Enable(31,False)
	    self.menu1.Enable(21,False)
	    self.SetStatusBar(wx.StatusBar(self,-1))
	    self.SetStatusText("BSPLab")
  
  	    self.Bind(wx.EVT_MENU, self.OnNew, id=10)
  	    self.Bind(wx.EVT_MENU, self.OnOpen, id=11)
  	    self.Bind(wx.EVT_MENU, self.OnSave, id=12)
            self.Bind(wx.EVT_MENU, self.OnExit, id=13)
            self.Bind(wx.EVT_MENU, self.OnSetup, id=31)
            self.Bind(wx.EVT_MENU, self.OnRun, id=41)
            
            self.Bind(wx.EVT_MENU, self.OnPltOpen, id=21)

            

            self.Bind(wx.EVT_SIZE, self.OnSize)


      

            # Konsollvindu
            win = wx.SashLayoutWindow(self, ID_WINDOW_BOTTOM, style=wx.NO_BORDER|wx.SW_3D)
            s=self.GetClientSize()
            print s
            win.SetDefaultSize((s[0], (s[1]*0.8)))
            win.SetOrientation(wx.LAYOUT_HORIZONTAL)
            win.SetAlignment(wx.LAYOUT_BOTTOM)
            win.SetSashVisible(wx.SASH_TOP, True)
            self.statusTxt=wx.TextCtrl(win, -1, "Ready\n",style=wx.TE_MULTILINE)
            self.statusTxt.SetEditable(False)
            self.statusTxt.SetMaxLength(1000000000)
            self.bottomWindow = win


            # Menyvundu til venstre side
            win =  wx.SashLayoutWindow(self, ID_WINDOW_LEFT1, style=wx.NO_BORDER|wx.SW_3D)
            win.SetDefaultSize((120, 1000))
            win.SetOrientation(wx.LAYOUT_VERTICAL)
            win.SetAlignment(wx.LAYOUT_LEFT)
            #win.SetBackgroundColour(wx.Colour(0, 255, 0))
            win.SetSashVisible(wx.SASH_RIGHT, True)
            win.SetExtraBorderSize(10)
            choice= []
            i=0
            self.pidList = wx.ListBox(win, 100, (5, 28), (50, 200),choice, wx.LB_SINGLE)      
            while i<=antPros:
                self.pidList.Insert(str(i),i)
               
             
                i=i+1
            #t=("Hjelp")
            #self.pidList.SetItemForegroundColour(self.pidList.GetItem(2), "BLUE")
            self.pidList.SetItemForegroundColour(2, "BLUE")
            #self.pidList.SetItemFont(3,wx.Font(8,wx.FONTFAMILY_DEFAULT,wx.FONTSTYLE_NORMAL,wx.FONTWEIGHT_BOLD)) 
            ##SetItemFont(3,wx.Font(8,wx.FONTFAMILY_DEFAULT,wx.FONTSTYLE_NORMAL,wx.FONTWEIGHT_BOLD))    
            self.Bind(wx.EVT_LISTBOX_DCLICK, self.EvtListBoxDClick, self.pidList)
            self.text= wx.StaticText(win, -1, "Processors", size=(150, 25),style=wx.RAISED_BORDER)
            self.startBtn = wx.Button(win,-1, "Start program", (2, 240), (110, 35))
            self.Bind(wx.EVT_BUTTON, self.EvtStart, self.startBtn)
            self.startBtn.Enable(False)
            self.ssCounterL=wx.StaticText(win,-1,'SuperStepNr',(2, 360))
            self.ssCounter=wx.StaticText(win,-1,'0',(2, 400))
            self.ssCounter.SetFont(wx.Font(30,wx.FONTFAMILY_MODERN, wx.FONTSTYLE_NORMAL,wx.FONTWEIGHT_BOLD,False))
            self.leftWindow1 = win
            win.Enable(1)

            


    def SetStatusTxt(self, txt):
        self.statusTxt.write(txt+"\n")
     

    def EvtListBoxDClick(self, event):
        self.newWindow(self.pidList.GetSelection()+1)
        
    def OnSashDrag(self, event):
        if event.GetDragStatus() == wx.SASH_STATUS_OUT_OF_RANGE:
            return

        eID = event.GetId()
        
        if eID == ID_WINDOW_TOP:
            self.topWindow.SetDefaultSize((1000, event.GetDragRect().height))

        elif eID == ID_WINDOW_LEFT1:
            self.leftWindow1.SetDefaultSize((event.GetDragRect().width, 1000))

        elif eID == ID_WINDOW_LEFT2:
            self.leftWindow2.SetDefaultSize((event.GetDragRect().width, 1000))

        elif eID == ID_WINDOW_BOTTOM:
            self.bottomWindow.SetDefaultSize((1000, event.GetDragRect().height))

        wx.LayoutAlgorithm().LayoutMDIFrame(self)
        self.GetClientWindow().Refresh()


    def OnSize(self, event):
        wx.LayoutAlgorithm().LayoutMDIFrame(self)
	if self.setupWin!=None:
		self.setupWin.SetSize(self.GetClientSize())
	print 'NEEEI'
    def EvtStart(self, event):
        
        self.readThread=BSPLab(self,-1,self.projectData)
    	self.readThread.start()
    		
    def OnRun(self,event):
    	if self.setupWin!=None:
    		self.setupWin.Destroy()
    		self.setupWin=None
    	self.bottomWindow.Show(True)
    	self.leftWindow1.Show(True)
    	self.OnSize(-1)
    	
    	

    def OnExit(self, evt):
        self.Close(True)
        
    def OnSave(self,event):
    	fil=open(self.projectData[1]+'/'+self.projectData[0]+".bpr",'w')
    	cPickle.dump(self.projectData, fil)
    	
    def OnOpen(self,event):
    	openWin = wx.FileDialog(
    	    self, message="Open BSPLab Project", defaultDir=os.getcwd(), 
    	    defaultFile="", wildcard="BSPLAb Project(*.bpr)|*.bpr", style=wx.OPEN 
    	    )
    	if openWin.ShowModal()==wx.ID_OK:
    	    file=open(openWin.GetPath())
    	    self.projectData=cPickle.load(file)
    	    print os.getcwd() 
 	    print self.projectData
 	    self.SetTitle('BSPLab - '+self.projectData[0])
 	    self.menu2.Enable(31,True)
 	    self.menu1.Enable(21,True)
 	    self.startBtn.Enable(True)	
 
    
    
        
    def OnNew(self,event):
    	path=""
    	dlg = wx.DirDialog(self, message="Where To Place The New BSPLab Project",
    	style=wx.OPEN | wx.CHANGE_DIR|wx.OK|wx.CANCEL)
    	if dlg.ShowModal() == wx.ID_OK:
    		path=dlg.GetPath()
    		dlgT=wx.TextEntryDialog(self,'Give The Project a Title:','Project Title',style=wx.OK|wx.CANCEL)
    		if dlgT.ShowModal()==wx.ID_OK:
    			name=dlgT.GetValue()
    			newpath=path+'/'+name
    			os.mkdir(newpath)
    			self.projectData.append(name)
    			self.projectData.append(newpath)
    			self.projectData.append(None)
    			self.projectData.append(None)
    			self.projectData.append(None)
    			self.projectData.append(None)
    			self.projectData.append({})
    			self.projectData.append([])
    			self.projectData.append(None)
    			self.projectData.append(self.workPath)
    			#self.projectData.append(None)#ProgTree
    			self.menu2.Enable(31,True)
    			self.menu1.Enable(21,True)
    			self.startBtn.Enable(True)	
    def OnSetup(self, evt):
        if self.setupWin!=None:
        	self.setupWin.Destroy()
        	self.setupWin=None
        self.setupWin= win
        self.bottomWindow.Show( False)
        self.leftWindow1.Show(False)
        self.OnSize(-1)
    def OnE(self,event):
   	self.setupWin.Destroy()
   	self.bottomWindow.Show(True)
        self.leftWindow1.Show(True)
       
   	self.OnSize(-1)
    
    def OnPltOpen(self,event):
   	win = plotSasha.ProSetup(self,self.projectData[6])
   	if self.setupWin!=None:
   		self.setupWin.Destroy()
   		self.setupWin=None
		#win.SetDefaultSize((1400,1000))
		#win.SetOrientation(wx.LAYOUT_HORIZONTAL)
		#win.SetAlignment(wx.LAYOUT_TOP)
		#win.SetBackgroundColour(wx.Colour(0, 0, 255))
		#win.SetSashVisible(wx.SASH_TOP, True)
		#self.statusTxt=wx.TextCtrl(win, -1, "Ready\n",style=wx.TE_MULTILINE)
		#self.statusTxt.SetEditable(False)
	self.setupWin= win
	self.bottomWindow.Show(False)
        self.leftWindow1.Show(False)
        self.OnSize(-1)

    def newWindow(self, pid):
        win = ProsFrame(self, pid, "Output from processor "+ str(pid-1))
        self.pidShow(pid, True)
        self.pidLista[pid-1][1]=win.txt
        #canvas = ScrolledWindow.MyCanvas(win)
        if self.pidLista[pid-1][2]!=None:
            t=self.pidLista[pid-1][2].Traverse()
            self.pidLista[pid-1][1].write(t)
        win.Show(True)
        #self.Tile(wx.HORIZONTAL)
    
        
    
        
    def writeFrame(self,pid, txt):
        
        if self.pidLista[pid-1][0]==True:
            r=self.pidLista[pid-1][1]
            r.write(txt)
            print "write"+str(pid)+str(txt)
        if self.pidLista[pid-1][2]==None:
            self.pidLista[pid-1][2]=HistoryList(3)
        self.pidLista[pid-1][2].add(txt)    
    
    def pidShow(self,pid, val):
        t=None
        print "pidval"+str(pid)+str(val)
        self.pidLista[pid-1][0]=val
        if val==False:
            self.pidLista[pid-1][1]= []

            #r.write(t)
    def SetCounter(self,i):
    	if i==0:
    		t=self.ssCounter.GetLabel()
        	t=int(t)+1
        	
        	t=self.ssCounter.SetLabel(str(t))
        else:
        	t=self.ssCounter.SetLabel('0')
    def writeParam(self,prdata,label):
    	data=self.projectData[6][label]
    	path=data[0]+'parameters.dat'
    	file=open(path,'w')      
    	i=0
    	if prdata[3]:
    		f='1'
    	else:
    		f='0'
    	if data[6][2]==0:
            outFile="ProbeResults.txt"
        else:
            outFile="ProbeResults_Run"+str(data[6][2])+".txt"
    	file.write('[RealTime] = '+f+'\n')
    	file.write('[Warnings] = '+str(prdata[4])+'\n')
    	file.write('[ProgressIndicator] = '+str(prdata[5])+'\n')
    	file.write('[Probe_OutputFileMaxSize] = '+str(10000000)+'\n')
    	file.write('[Probe_OutputFilename] = '+outFile+'\n')
	for element in data[4][0]:
		t=data[4][0][i]+" = "+data[4][1][i]+'\n'
		file.write(t)
		i=i+1
	i=0
	for element in data[5][0]:
		t=data[5][0][i]+" = "+data[5][1][i]+'\n'
		file.write(t)
		i=i+1
	i=0
	for element in prdata[7][0]:
		t=prdata[7][0][i]+" = "+str(prdata[7][1][i])+'\n'
		file.write(t)
		i=i+1
#----------------------------------------------------------------------
#Prosessor vinduer
class ProsFrame(wx.MDIChildFrame):
    def __init__(self,parent, pid,title):
        t=None
        self.pide=pid
        self.par=parent
        print "pid:"+str(pid)+"title"+title
        wx.MDIChildFrame.__init__(self, parent,-1, title)
        self.txt=wx.TextCtrl(self, -1, "", style=wx.TE_MULTILINE)
        self.txt.SetEditable(False)    
        self.Show(True)
        self.Bind(wx.EVT_CLOSE, self.OnCloseWindow)

    def getPid(self):
        return self.pide


    def OnCloseWindow(self, event):
            print "Her:"+str(self.pide)
            self.par.pidShow(self.pide, False)
            self.Destroy()
#--------------------------------------------------------------------            
#En node i HistoryList som inneholder utskriften (txt)
class ListNode:
    def __init__(self,txt,prev):
        self.prev=prev
        self.nxt=None
        self.txt=txt


    def add(self,newNode):
        self.nxt=newNode
        

    def remove(self):
            self.nxt.removePrev(None)
            self.nxt=None

    def removePrev(self, val):
        self.prev=None
        

    def Get(self):
        return sel
    
        
#Klasse for  lagre en gitt antall (num) utskrifter i historikk for en prosessor    
class HistoryList:
    def __init__(self, num):
        self.number=num
        self.first=None
        self.last=None
        self.count=0
        r=None
    def add(self,val):
        self.val=val
        
        if self.first==None:
           self.last=self.first=ListNode(self.val,None)
           self.count=self.count+1
        else:
            self.first=ListNode(val,self.first)
            self.first.prev.nxt=self.first
            self.count=self.count+1
        if self.count> self.number:
            r=self.last.nxt
            self.last.remove()
            self.last=r
            self.count=self.count-1
        
    def get(self):
        t=self.first.txt
        r=self.first.prev
        self.first.prev=None
        self.first=r
        self.count=self.count-1
        return t
    def Traverse(self):
        t=""
        while self.count>0:
            t=self.get()+ t 
        return t
#----------------------------------------------------------------------        
#Trd som parser output fra bspprogram
class BSPLab(threading.Thread):
	def __init__(self,parent,id,prog):
                threading.Thread.__init__(self, name="runThread")
		self.progData=prog
		self.parent=parent
                #self.frame = MyParentFrame(1000,self)
                #self.frame.start()
                #self.frame.Show(True)
                #self.frame.Maximize(True)
                
        def run(self):
        	keys=self.progData[6].keys()
        	for item in keys:
        		self.parent.writeParam(self.progData,item)
        		self.path=self.progData[6][item][0]
        		self.prog=self.progData[6][item][1]
       		        self.parent.SetStatusTxt("BSPLab program "+item+" started\n")
       		        i=0
       		        os.chdir(self.path)
       		        self.parent.SetCounter(1)
       		        
       		        if self.progData[6][item][7]=="":
                            
                            test= os.popen4(self.path+self.prog)
                        else:
                            test= os.popen4(str(self.path+self.prog)+' '+self.progData[6][item][7])
       		       
       		        i=0
       		        #print test[1]

       		        for line in test[1]:
       		          #print line 	 
       		          inLine=line#test[1].readline()  
       		          i=0
       		          meld=""
       		          
       		          #if inLine=="":
       		          #    break

       		          lengde=len(inLine)

       		          if inLine[i] !='?':
       		              
       		              if inLine[i] =='.':
			        
       		          	self.parent.SetCounter(0)
       		              else:
       		              	self.parent.SetStatusTxt(inLine)
       		          
       		          
       		          else:
       		              	
       		          
       		              i=i+1
       		              if inLine[i]=='S':
       		                  i=i+2
       		                  pid=int(inLine[i])
       		                  
       		                  i=i+3
       		                  while i<lengde:
       		                      meld=meld+inLine[i]
       		                      i=i+1
       		                  self.parent.writeFrame(pid+1,meld)
       		              elif inLine[i]=='P':
       		                  if inLine[i]=='S':
       		                      i=i+4
       		                      pid=int(inLine[i])
       		                      print "I "+str(i)
       		                      i=i+3
       		                      while i<lengde:
       		                          meld=meld+inLine[i]
       		                          i=i+1
       		                      



         #returnerer lengden p stringen s     

        def length(self,s):
            i=0    
            for char in s:
              i=i+1
            return i
            
        
       	
       	
#--------------------------------------------------------------------------

if __name__ == '__main__':
    class MyApp(wx.App):
        def OnInit(self):
            wx.InitAllImageHandlers()
            #framer = BSPLab(None, -1)
            		
	    self.frame = MyParentFrame(1000,self)
	    #self.frame.start()
	    self.frame.Show(True)
            self.frame.Maximize(True)
            
            
            

            return True



    app = MyApp(False)
    app.MainLoop()
   


